
//IMPLEMENTATION of CConfigFile Class
//09.03.2001 
/////////////////////////////////////


#include "stdafx.h"
#include "ConfigFile.h"

#define INI_FILE	".\\sharks.ini"
#define BUFFER_MAX	50

//Private subs
CString CConfigFile::getProfileString(LPCTSTR lpSection, LPCTSTR lpKey, LPCTSTR lpDefault)
{
	DWORD b;
	char buffer[BUFFER_MAX];

	b = GetPrivateProfileString(lpSection, lpKey, lpDefault, buffer, BUFFER_MAX, INI_FILE);
	return buffer;
}

long CConfigFile::getProfileInt(LPCTSTR lpSection, LPCTSTR lpKey, unsigned int aiDefault)
{
	long tmpI;
	tmpI = GetPrivateProfileInt(lpSection, lpKey, aiDefault, INI_FILE);
	return tmpI;
}

// Configurations for soccerserver
CConfigFile::CConfigFile()
{
        // width of goals (default 7.32)
        goal_width        = 14.02f;

        // size, decay, random parameter, weight, maximum speed of players
        // (default 1.0, 0.5, 0.1, 60.0, 32.0)
         player_size       = 0.3f;
         player_decay      = 0.4f;
         player_rand       = 0.1f;
         player_weight     = 60.0f;
         player_speed_max  = 1.0f;

        // maximum and recovery step of player's stamina (default 2500.0, 50.0)
         stamina_max       = 3500;
        // 35.0;
         stamina_inc_max   = 3500;

        // decriment threshold ,decriment step and minimum of player's recovery;
        // (default 0.3, 0.05, 0.1);
         recover_dec_thr   = 0.3f;
         recover_dec       = 0.002f;
         recover_min       = 0.5f;

        // decriment threshold, decriment step, incriment threshold, incriment step;
        // and minimum of player's effort (default 0.4, 0.05, 0.9, 0.05, 0.1);
         effort_dec_thr    = 0.3f;
         effort_dec        = 0.005f;
         effort_inc_thr    = 0.6f;
         effort_inc        = 0.01f;
         effort_min        = 0.6f;

        // maximum, recovery step and decay of player's hear capacity (default 2, 1, 1);
         hear_max          = 2;
         hear_inc          = 1;
         hear_decay        = 2;

        // inertia moment of player (default 5.0);
         inertia_moment    = 5.0f;

        // erval of sense_body (default 100);
         sense_body_step   = 100;

        // goalie catchable area length, width (default 2.0, 1.0);
         catchable_area_l  = 2.0f;
         catchable_area_w  = 1.0f;

        // goalie catchbale probability (default 1.0);
         catch_probability = 1.0;

        // goalie catch ban cycle (default 5);
         catch_ban_cycle   = 5;

        // size, decay, random parameter, weight and maximum speed of a ball;
        // (default 0.15, 0.8, 0.2, 0.2, 32.0);
         ball_size         = 0.085f;
         ball_decay        = 0.94f;
         ball_rand         = 0.05f;
         ball_weight       = 0.2f;
         ball_speed_max    = 2.7f;

        // force, direction and random parameter of wind (default 10.0, 0.0, 0.3);
         wind_force        = 0.0;
         wind_dir          = 0.0;
         wind_rand         = 0.0;

        // kickable margin (default 1.0) kickable_area = kickable_margin + bsize + psize;
         kickable_margin   = 0.7f;

        // corner kick margin (default 1.0);
         ckick_margin    = 1.0f;

        // magnification of power in dash, kick  (default 0.1, 0.1);
         dash_power_rate = 0.006f;
        //kick_power_rate   = 0.013;
         kick_power_rate = 0.016f;

        // angle of view corn [unit= degree] (default 90.0);
         visible_angle   = 90.0;

        // audio cut off distance (default 50.0);
         audio_cut_dist  = 50.0;

        // quantize step of distance for move_object, landmark (default 0.1, 0.01);
         quantize_step       = 0.1f;
         quantize_step_l     = 0.01f;

        // max and min of power in dash and kick (default 100, -30);
         maxpower        = 100;
         minpower        = -100;

        // max and min of power in turn (default 180, -180);
         maxmoment       = 180;
         minmoment       = -180;

        // max and min of power in turn_neck (default 180,-180);
         maxneckmoment   = 180;
         minneckmoment   = -180;

        // max and min of neck angle (default 90, -90);
         maxneckang      = 90;
         minneckang      = -90;

        // Default port number (default 6000);
         port            = 6000;

        // Default coach port number (default 6001);
         coach_port      = 6001;

        // Default upper limit of the number of online coach's message (default 128);
         say_coach_cnt_max       = 128;

        // Default upper limit of length of online coach's message (default 128);
         say_coach_msg_size      = 128;

        // Default erval of online coach's look (default 100);
         send_vi_step            = 100;

        // time step of simulation [unit=msec] (default 100);
         simulator_step  = 100;

        // time step of visual information [unit=msec] (default 150);
         send_step       = 150;

        // time step of acception of command [unit= msec] (defalut 20);
         recv_step       = 10;

        // length of half of game [unit=sec] (default 6000);
        // (if negative, a game does not stop automatically);
         half_time       = 300;
        //half_time     = 30000;

        // string size of say message [unit=byte] (default 256);
         say_msg_size    = 512;

        // flag for using off side rule. [on/off] (default on);
        //use_offside       = on;
         use_offside     = 0;

        // offside active area size (default 9.15);
        //offside_active_area_size  = 9.15;
         offside_active_area_size    = 5;

        // forbid kick off offside. [on/off] (default on);
         forbid_kick_off_offside = 1;

        // flag for verbose mode. [on/off] (default off);
         verbose         = 0;

        // flag for record log. (default 2);
        // (old version 1);
         record_version  = 2;

        // flag for record client command log. [on/off] (default off);
         record_log      = 0;

        // flag for send client command log. [on/off] (default on);
         send_log        = 1;

        // offside kick margin. (default 9.15);
         offside_kick_margin = 5.0;


//****************************************************************
		//inicializacia pomocnych premennych
		 ServerName = "";
		 TeamName = "";
		 ServerSocket=NULL;

		 Goalie = -1;

		pp[0]=CRealPoint(-50,0);
		pp[1]=CRealPoint(-50,0);
		pp[2]=CRealPoint(-35,0);
		pp[3]=CRealPoint(-17,0);
		pp[4]=CRealPoint(0,0);
		pp[5]=CRealPoint(17,0);
		pp[6]=CRealPoint(36,0);

		pp[7]=CRealPoint(26,-20);
		pp[8]=CRealPoint(26,0);
		pp[9]=CRealPoint(26,20);
		pp[10]=CRealPoint(-30,-15);
		pp[11]=CRealPoint(-30,15);
}

CString CConfigFile::defaultServerName()
{
	if (ServerName=="") {
		ServerName = getProfileString("SERVER", "SERVER_NAME", "localhost" );
	}
	return ServerName;
}

CString CConfigFile::defaultTeamName()
{
	if (TeamName=="") {
		TeamName = getProfileString("TEAM", "TEAM_NAME", "DynamoSharks");
	}
	return TeamName;
}

long CConfigFile::defaultServerSocket()
{
	if (ServerSocket==NULL) {
		ServerSocket = getProfileInt("SERVER", "SERVER_SOCKET", port);
	}
	return ServerSocket;
}

int CConfigFile::defaultGoalie()
{
	CString tmpS;

	if (Goalie==-1) {
		tmpS = getProfileString("PLAYER", "GOALIE", "No");
		if (tmpS == "Yes") 
			Goalie = 1;
		else 
			Goalie = 0;
	}
	return Goalie;
}

CRealPoint CConfigFile::defaultPlayerPos(int UniformNum, BOOL side, BOOL goalie)
{
	CRealPoint tmp;

	if (goalie) {
		tmp = pp[0];
	}
	else {
		tmp = pp[UniformNum];
	}

	if (!side) { tmp.x *= -1; }

	return tmp;
}

void CConfigFile::loadPositions()
{
	CRealPoint tmp;
	int x,y;
	CString str, pos;


	for (int i=0;i<12;i++) {

		pos.Format("pos%d",i);
		str = getProfileString("POSITION",(LPCSTR) pos, "0;0;");

		sscanf((LPCTSTR)str,"%d;%d;",&x,&y);
		tmp.x = x;
		tmp.y = y;
		pp[i] = tmp;
	}
}

BOOL CConfigFile::isConfigReady()
{
	DWORD b;
	char buffer[BUFFER_MAX];
	char DEFAULTMENO[13] = "[ziadnemeno]";
	
	b = GetPrivateProfileString("TEAM", "TEAM_NAME", DEFAULTMENO, buffer, BUFFER_MAX, INI_FILE);

	if (! strcmp(buffer,DEFAULTMENO)) {
		return FALSE;
	}
	else {
		return TRUE;
	}
}
