// Environment.cpp: implementation of the CEnvironment class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Sharks.h"
#include "Environment.h"
#include "SharkTypes.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CEnvironment::CEnvironment()
{
	Me.head_angle = 0;				// na zaciatku je krk rovnobezny s telom
	Me.body_angle = 0;				// na zaciatku je telo smerom na "vychod"
	Me.speed = 0;					// nulova rychlost
	Me.stamina = stamina_max;		// pociatocna stamina na maximum
	Me.vwidth = normal;				// sirka pohladu na normale
	Me.UniformNumber=0;

	Me.MyPosition.y= -37;	//na zacitatku na tam praskne

	Lopta.MyPosition.x=0;
	Lopta.MyPosition.y=0;
	Lopta.resetProbability();	//viem ze ta hlupana je na zac. v strede


	ZOOM = 3.0;							//zvacsenie ihriska
	PLAYER_WIDTH=4;						//velkost hraca
	BALL_WIDTH=2;						//velkost lopty

	drawDRES = TRUE;
	drawVIEW = TRUE;
}

CEnvironment::~CEnvironment()
{
}

/*
	Zisuje suradnice flagov
	(moze tu byt chyba)
*/
void CEnvironment::GetLandmarkPos(DWORD prop1,DWORD prop2,DWORD prop3,double *X, double *Y)
{

	BOOL pom;
	double pomhod;

	if(prop1==F_CENTER) //v strede ihriska
	{
		*X=0;
		switch(prop2)
		{
		case F_TOP:
			*Y=-FHEIGHT;
			break;
		case F_BOTTON:
			*Y=FHEIGHT;
			break;
		case F_EMPTY:
			*Y=0;
		}

		return;
	}

	if(prop1==F_GOAL) //brankove
	{
		if(prop2 == F_LEFT) //lava brankova
		{
			*X=-FWIDTH;
		}
		else //prava brankova
		{
			*X=FWIDTH;
		}
		
		if(prop3 == F_TOP)
		{
			*Y=-goal_width/2;
		}
		else
		{
			*Y=goal_width/2;
		}
		return;
	}

	if(prop1==F_GOALFLAG) //jedna z branok
	{
		*Y=0;
		if(prop2 == F_LEFT)
		{
			*X=-FWIDTH;
		}
		else
		{
			*X=FWIDTH;
		}
		return;
	}

	if(prop1 == F_PENALTY) //penaltove
	{
		if(prop2 == F_LEFT)
		{
			*X=-PWIDTH;
		}
		else
		{
			*X=PWIDTH;
		}

		switch(prop3)
		{
		case F_TOP:
			*Y=-PHEIGHT;
			break;
		case F_BOTTON:
			*Y=PHEIGHT;
			break;
		case F_CENTER:
			*Y=0;
			break;
		}
		return;
	}

	if(prop1 == F_LEFT) //na lavom okraji
	{
		if(prop2 == F_0)
		{
			*X=-FWIDTH-5;
			*Y=0;
			return;
		}

		if(prop3 == F_EMPTY)
		{
			*X=-FWIDTH;
			*Y= (prop2==F_TOP) ? -FHEIGHT : FHEIGHT;
			return;
		}

		*X=-FWIDTH-5;
		pom=(prop2==F_TOP);
		
		switch(prop3)
		{
		case F_10:
			pomhod=10;
			break;
		case F_20:
			pomhod=20;
			break;
		case F_30:
			pomhod=30;
			break;
		}

		if(pom)
			*Y=-pomhod;
		else
			*Y=pomhod;
		return;
	}

	if(prop1 == F_RIGHT) //na pravom okraji
	{
		if(prop2 == F_0)
		{
			*X=FWIDTH+5;
			*Y=0;
			return;
		}

		if(prop3 == F_EMPTY)
		{
			*X=FWIDTH;
			*Y= (prop2==F_TOP) ? -FHEIGHT : FHEIGHT;
			return;
		}

		*X=FWIDTH+5;
		pom=(prop2==F_TOP);
		
		switch(prop3)
		{
		case F_10:
			pomhod=10;
			break;
		case F_20:
			pomhod=20;
			break;
		case F_30:
			pomhod=30;
			break;
		}

		if(pom)
			*Y=-pomhod;
		else
			*Y=pomhod;
		return;
	}

	if(prop1==F_TOP) //na hornom okraji
	{
		*Y=-FHEIGHT-5;

		if(prop2==F_0)
		{
			*X=0;
			return;
		}

		pom=(prop2==F_LEFT);
		switch(prop3)
		{
		case F_10:
			pomhod=10;
			break;
		case F_20:
			pomhod=20;
			break;
		case F_30:
			pomhod=30;
			break;
		case F_40:
			pomhod=40;
			break;
		case F_50:
			pomhod=50;
		}

		if(pom)
			*X=-pomhod;
		else
			*X=pomhod;
		return;
	}

	if(prop1==F_BOTTON) //na dolnom okraji
	{
		*Y=FHEIGHT+5;

		if(prop2==F_0)
		{
			*X=0;
			return;
		}

		pom=(prop2==F_LEFT);
		switch(prop3)
		{
		case F_10:
			pomhod=10;
			break;
		case F_20:
			pomhod=20;
			break;
		case F_30:
			pomhod=30;
			break;
		case F_40:
			pomhod=40;
			break;
		case F_50:
			pomhod=50;
		}

		if(pom)
			*X=-pomhod;
		else
			*X=pomhod;
		return;
	}

	MsgB("Neznama vlajka");
}

/*
	Vracia FALSE ak polohu neurcuje
	Absolutnu polohu urcuje s pribliznou spolahlivostou +/- 1.0
*/
BOOL CEnvironment::CalcAbsPos(VizInfo *vinfo, double* X, double* Y,double* viewdir)
{
	if(vinfo->nFlagy==0) return FALSE;

	double AbsDirection;
	double max_dist=0;
	unsigned i;

	if(vinfo->nCiary==0) //nevidim ciaru
	{
		AbsDirection=Me.body_angle+Me.head_angle;
	}
	else //vidim ciaru
	{
	double pomDir;

	for(i=0;i<vinfo->nCiary;i++)
	{
		if(max_dist<vinfo->Ciary[i].distance)
		{
			max_dist=vinfo->Ciary[i].distance;
			pomDir=vinfo->Ciary[i].direction;

			switch(vinfo->Ciary[i].properties)
			{
			case L_LEFT:
				if(pomDir>=0)
					AbsDirection=-90-pomDir;
				else
					AbsDirection=90-pomDir;
				break;
			case L_RIGHT:
				if(pomDir>=0)
					AbsDirection=90-pomDir;
				else
					AbsDirection=-90-pomDir;
				break;
			case L_TOP:
				if(pomDir>=0)
					AbsDirection=-pomDir;
				else
					AbsDirection=-180-pomDir;
				break;
			case L_BOTTON:
				if(pomDir>=0)
					AbsDirection=180-pomDir;
				else
					AbsDirection=-pomDir;
				break;
			}
		}
	}
	}

	*viewdir=AbsDirection;
	double px,py;

	max_dist=vinfo->Flagy[0].distance;

	for(i=0;i<vinfo->nFlagy;i++)
	{
		double lmdistance;
		lmdistance=vinfo->Flagy[i].distance;
		if(lmdistance<=max_dist) //zistuje podla najblizsej
		{
			max_dist=lmdistance;
			GetLandmarkPos(vinfo->Flagy[i].prop1,vinfo->Flagy[i].prop2,vinfo->Flagy[i].prop3,&px,&py);

			double dir=(AbsDirection + vinfo->Flagy[i].direction)*PICKO/180;

			*X=px-lmdistance*cos(dir);
			*Y=py-lmdistance*sin(dir);
		}
	}

	return TRUE;
}


// inicializacia sveta, bude sa volat z Handler_See
// 1.oprava mojej pozicie (absolutna poloha)
// 2.vyhodenie hracov v uhle pohladu z pamati
// 3.naplnenie sveta podla VizInfo
void CEnvironment::updateWorld(VizInfo *Data)
{

	double vd, uhol, dist;
	unsigned int i;
	CPlayer tmpPlayer;
			CString s;

	// ja 
	//pozicia
	if (CalcAbsPos(Data, &Me.MyPosition.x, &Me.MyPosition.y, &vd)) {
		//uhol tela
		Me.body_angle = vd - Me.head_angle;
	}

	//vyhodit vsetky objekty, ktore su v mojom uhle pohladu
	removePlayersInView();

	// nasi
	for(i=0;i< Data->nNasi;i++)
	{
		tmpPlayer.Flag = Data->Nasi[i].properties;
		uhol=(vd + Data->Nasi[i].direction)*PICKO/180;
		dist=Data->Nasi[i].distance;
		tmpPlayer.MyPosition.x = dist*cos(uhol) + Me.MyPosition.x;
		tmpPlayer.MyPosition.y = dist*sin(uhol) + Me.MyPosition.y;
		if(Data->Nasi[i].properties & P_NUMBER)
		{
			tmpPlayer.UniformNumber = Data->Nasi[i].UniformNumber;
		}
		if((Data->Nasi[i].properties & (P_DISTCHNG|P_DIRCHNG)) == (P_DISTCHNG|P_DIRCHNG))
		{
			tmpPlayer.setProps(Me.MyPosition.x, Me.MyPosition.y, Me.speed*cos(Me.body_angle*PICKO/180), Me.speed*sin(Me.body_angle*PICKO/180), Data->Nasi[i].dirchng, Data->Nasi[i].distchng);
		}

		tmpPlayer.resetProbability();
		addNas(tmpPlayer);
	}

	// cudzi
	for(i=0;i< Data->nCudzi;i++)
	{
		tmpPlayer.Flag = Data->Cudzi[i].properties;
		uhol=(vd + Data->Cudzi[i].direction)*PICKO/180;
		dist=Data->Cudzi[i].distance;
		tmpPlayer.MyPosition.x = dist*cos(uhol) + Me.MyPosition.x;
		tmpPlayer.MyPosition.y = dist*sin(uhol) + Me.MyPosition.y;
		if(Data->Cudzi[i].properties & P_NUMBER)
		{
			tmpPlayer.UniformNumber = Data->Cudzi[i].UniformNumber;
		}
		if((Data->Cudzi[i].properties & (P_DISTCHNG|P_DIRCHNG)) == (P_DISTCHNG|P_DIRCHNG))
		{
			tmpPlayer.setProps(Me.MyPosition.x, Me.MyPosition.y, Me.speed*cos(Me.body_angle*PICKO/180), Me.speed*sin(Me.body_angle*PICKO/180), Data->Cudzi[i].dirchng, Data->Cudzi[i].distchng);
		}
		
		tmpPlayer.resetProbability();
		addCudzi(tmpPlayer);
	}
	//*********************************************

	// lopta
	if(Data->lpLopta->properties)
	{
		uhol = (vd + Data->lpLopta->direction)*PICKO/180;
		dist = Data->lpLopta->distance;
		
		Lopta.MyPosition.x = (Me.MyPosition.x + dist*cos(uhol));
		Lopta.MyPosition.y = (Me.MyPosition.y + dist*sin(uhol));
		
		//nastavenie smeru a rychlosti lopty
		if((Data->lpLopta->properties & (P_DISTCHNG|P_DIRCHNG)) == (P_DISTCHNG|P_DIRCHNG))
		{
			Lopta.setProps(Me.MyPosition.x, Me.MyPosition.y, Me.speed*cos(Me.body_angle*PICKO/180), Me.speed*sin(Me.body_angle*PICKO/180), Data->lpLopta->dirchng, Data->lpLopta->distchng);
		}
		Lopta.resetProbability();
	}
}

//vykresli mna
void CEnvironment::drawMe(CDC &dc, float x0, float y0)
{
	double minAngle, maxAngle;
	double x,y;
	double viewR;
	//ja
	viewR = ZOOM*20;
	x = x0+ ZOOM*Me.MyPosition.x;
	y = y0+ ZOOM*Me.MyPosition.y;

	CBrush g(RGB(0,128,0));

	CBrush* oldB=dc.SelectObject(&g);
	dc.Ellipse(int(x)-PLAYER_WIDTH, int(y)-PLAYER_WIDTH, int(x)+PLAYER_WIDTH, int(y)+PLAYER_WIDTH);

	if (drawVIEW) {
		switch (Me.vwidth) {
			case narrow: 
				minAngle = - 22.5; 
				maxAngle = + 22.5; 
				break;
			case normal: 
				minAngle = - 45; 
				maxAngle = + 45; 
				break;
			case wide: 
				minAngle = - 90; 
				maxAngle = + 90; 
				break;
		}
		minAngle += (Me.body_angle + Me.head_angle);
		maxAngle += (Me.body_angle + Me.head_angle);

		dc.MoveTo(int(x),int(y));
		dc.LineTo(int(x + viewR*cos(minAngle*PICKO/180)),int(y + viewR*sin(minAngle*PICKO/180)));
		dc.MoveTo(int(x),int(y));
		dc.LineTo(int(x + viewR*cos(maxAngle*PICKO/180)),int(y + viewR*sin(maxAngle*PICKO/180)));

		dc.Arc(int(x-viewR),int(y-viewR),int(x+viewR),int(y+viewR),int(x + viewR*cos(maxAngle*PICKO/180)),int(y + viewR*sin(maxAngle*PICKO/180)), int(x + viewR*cos(minAngle*PICKO/180)),int(y + viewR*sin(minAngle*PICKO/180)));
	}

	if (drawDRES)
	{
		CString cislo;
		cislo.Format("%d",Me.UniformNumber);
		dc.SetTextColor(RGB(0,128,0));
		dc.TextOut(int(x),int(y),cislo);
	}

	dc.SelectObject(oldB);

}
//vykresli loptu
void CEnvironment::drawBall(CDC &dc, float x0, float y0)
{
	//lopta
	CBrush b(RGB(0,0,255));
	CPen p(PS_SOLID,1,RGB(0,0,0));

	if (Lopta.probability) {
		CBrush* oldB=dc.SelectObject(&b);
		CPen* oldP=dc.SelectObject(&p);
		dc.Ellipse(int(x0 + ZOOM*Lopta.MyPosition.x)-BALL_WIDTH, int(y0+ ZOOM*Lopta.MyPosition.y)-BALL_WIDTH, int(x0+ ZOOM*Lopta.MyPosition.x)+BALL_WIDTH, int(y0+ ZOOM*Lopta.MyPosition.y)+BALL_WIDTH);
		dc.SelectObject(oldB);
		dc.SelectObject(oldP);

		CPlayer tmpLopta(Lopta);
		do
		{
			tmpLopta=stepBall(tmpLopta,1);
			dc.SetPixelV(int(x0+ZOOM*tmpLopta.MyPosition.x),int(y0+ZOOM*tmpLopta.MyPosition.y),RGB(0,0,255));
		}
		while(tmpLopta.probability>0);
	}
}
//vykresli spoluhraca
void CEnvironment::drawFriend(CDC &dc, CPlayer &Hrac, float x0, float y0)
{
	CBrush g(RGB(0,255,0));
	CString cislo;

	CBrush* oldB=dc.SelectObject(&g);
	dc.Ellipse(int(x0+ ZOOM*Hrac.MyPosition.x)-PLAYER_WIDTH, int(y0+ ZOOM*Hrac.MyPosition.y)-PLAYER_WIDTH, int(x0+ ZOOM*Hrac.MyPosition.x)+PLAYER_WIDTH, int(y0+ ZOOM*Hrac.MyPosition.y)+PLAYER_WIDTH);
	dc.SetTextColor(RGB(0,255,0));
	if (drawDRES) {
		if (Hrac.Flag & P_NUMBER) {
			cislo.Format("%d", Hrac.UniformNumber);
		}
		dc.TextOut(int(x0+ ZOOM*Hrac.MyPosition.x)+5,int(y0+ ZOOM*Hrac.MyPosition.y),cislo);
	}
	//cislo.Format("%3.2f", Hrac.probability);
	//dc.TextOut(int(x0+ ZOOM*Hrac.MyPosition.x)+5,int(y0+ ZOOM*Hrac.MyPosition.y)+15,cislo);

	dc.SelectObject(oldB);
}
//vykresli protihraca
void CEnvironment::drawEnemy(CDC &dc, CPlayer &Hrac, float x0, float y0)
{
	CBrush r(RGB(255,0,0));
	CString cislo;

	CBrush* oldB=dc.SelectObject(&r);
	dc.Ellipse(int(x0+ ZOOM*Hrac.MyPosition.x)-PLAYER_WIDTH, int(y0+ ZOOM*Hrac.MyPosition.y)-PLAYER_WIDTH, int(x0+ ZOOM*Hrac.MyPosition.x)+PLAYER_WIDTH, int(y0+ ZOOM*Hrac.MyPosition.y)+PLAYER_WIDTH);
	dc.SetTextColor(RGB(255,0,0));
	if (drawDRES) {
		if (Hrac.Flag & P_NUMBER) {
			cislo.Format("%d", Hrac.UniformNumber);
		}
		dc.TextOut(int(x0+ ZOOM*Hrac.MyPosition.x)+5,int(y0+ ZOOM*Hrac.MyPosition.y),cislo);
	}

	dc.SelectObject(oldB);
}
//vykresli ihrisko
void CEnvironment::drawPlayground(CDC &dc, CRect Rect, float wr_x, float wr_y)
{

	//okraje
	dc.MoveTo(int(wr_x-ZOOM*FWIDTH),int(wr_y-ZOOM*FHEIGHT));
	dc.LineTo(int(wr_x+ZOOM*FWIDTH),int(wr_y-ZOOM*FHEIGHT));
	dc.LineTo(int(wr_x+ZOOM*FWIDTH),int(wr_y+ZOOM*FHEIGHT));
	dc.LineTo(int(wr_x-ZOOM*FWIDTH),int(wr_y+ZOOM*FHEIGHT));
	dc.LineTo(int(wr_x-ZOOM*FWIDTH),int(wr_y-ZOOM*FHEIGHT));
	//stredova ciara
	dc.MoveTo(int(wr_x),int(wr_y-ZOOM*FHEIGHT));
	dc.LineTo(int(wr_x),int(wr_y+ZOOM*FHEIGHT));
	//kruh
	const float RK3=ZOOM*8.5f;
	dc.Arc(int(wr_x-RK3),int(wr_y-RK3),int(wr_x+RK3),int(wr_y+RK3),int(wr_x-RK3),int(wr_y),int(wr_x-RK3),int(wr_y));
	//lave pokutove
	dc.MoveTo(int(wr_x-ZOOM*FWIDTH),int(wr_y-ZOOM*PHEIGHT));
	dc.LineTo(int(wr_x-ZOOM*PWIDTH),int(wr_y-ZOOM*PHEIGHT));
	dc.LineTo(int(wr_x-ZOOM*PWIDTH),int(wr_y+ZOOM*PHEIGHT));
	dc.LineTo(int(wr_x-ZOOM*FWIDTH),int(wr_y+ZOOM*PHEIGHT));
	//prave pokutove
	dc.MoveTo(int(wr_x+ZOOM*FWIDTH),int(wr_y-ZOOM*PHEIGHT));
	dc.LineTo(int(wr_x+ZOOM*PWIDTH),int(wr_y-ZOOM*PHEIGHT));
	dc.LineTo(int(wr_x+ZOOM*PWIDTH),int(wr_y+ZOOM*PHEIGHT));
	dc.LineTo(int(wr_x+ZOOM*FWIDTH),int(wr_y+ZOOM*PHEIGHT));
	//lava branka
	dc.SetPixelV(int(wr_x-ZOOM*FWIDTH),int(wr_y-(ZOOM/2.0)*goal_width),0);
	dc.SetPixelV(int(wr_x-ZOOM*FWIDTH),int(wr_y+(ZOOM/2.0)*goal_width),0);
	//prava branka
	dc.SetPixelV(int(wr_x+ZOOM*FWIDTH),int(wr_y-(ZOOM/2.0)*goal_width),0);
	dc.SetPixelV(int(wr_x+ZOOM*FWIDTH),int(wr_y+(ZOOM/2.0)*goal_width),0);

}

void CEnvironment::drawMemory(CDC &dc, CRect Rect)
{
	CPen pero(PS_SOLID,0,RGB(128,128,128));
	CPen *stare;
	float wr_x,wr_y;
	CString cislo;
	int i;

	dc.FillSolidRect(&Rect,RGB(192,192,192));
	dc.SetBkMode(TRANSPARENT);

	wr_x=Rect.Width() /2.0f;
	wr_y=Rect.Height()/2.0f;

	stare=dc.SelectObject(&pero);	

	drawPlayground(dc, Rect, wr_x, wr_y);
	drawMe(dc, wr_x, wr_y);
	drawBall(dc, wr_x, wr_y);

	dc.SetTextColor(0);
	cislo.Format("X=%.0f Y=%.0f",Me.MyPosition.x,Me.MyPosition.y);
	dc.TextOut(0,0,cislo);
	cislo.Format("nCudzi=%d  nNasi=%d", Cudzi.GetSize(), Nasi.GetSize());
	dc.TextOut(0,10,cislo);

	for (i=0;i<Nasi.GetSize();i++){
		drawFriend(dc, Nasi[i], wr_x, wr_y);
	}
	for (i=0;i<Cudzi.GetSize();i++){
		drawEnemy(dc, Cudzi[i], wr_x, wr_y);
	}

	dc.SelectObject(stare);
}


void CEnvironment::updateMyBody(SenseBodyInfo *Info)
{
	Me.head_angle=Info->head_angle;
	Me.speed = Info->speed;
	Me.stamina = Info->stamina;
	Me.vwidth = Info->vwidth;
}

//Step je pocet cyklov o ktore sa ma objekt posunut
void CEnvironment::stepWorld(int Step)
{
	CString s;
	int i;
	//posun mna
	stepMe(Step);

	//vyhodime starych
	removeOlds();

	//posun lopty
	Lopta=stepBall(Lopta, Step);
	//posun mojich hracov
	for (i=0; i < Nasi.GetSize(); i++)
	{
		Nasi[i] = stepPlayer(Nasi[i], Step);
//		s.Format("index: %d p: %.2f \n",i,Nasi[i].probability);
//		cPrint(s);
	}

	//posun cudzich
	for (i=0; i < Cudzi.GetSize(); i++)
	{
		Cudzi[i] = stepPlayer(Cudzi[i], Step);
	}

	//vyhodime starych
	removeOlds();
}


CPlayer CEnvironment::stepBall(const CPlayer& LoptaOrig, int Step)
{
	//posun lopty
	//podla speed, angle, ball_decay, x a y lopty
	CPlayer tmpLopta(LoptaOrig);

	for (int i=1;i<=Step;i++) {
		tmpLopta.MyPosition.x += tmpLopta.speedX;
		tmpLopta.MyPosition.y += tmpLopta.speedY;
		tmpLopta.speedX *= this->ball_decay;
		tmpLopta.speedY *= this->ball_decay;
		//znizim urcitost pamate (pri lopte dvojnasobne)
		tmpLopta.lowerProbability(2*PROBABILITY_STEP);	
	}

	return tmpLopta;
}


void CEnvironment::stepMe(int Step)
{
	//posun mna
	//podla x a y, speed, body_angle, player_decay
	for (int i=1;i<=Step;i++) {
		Me.MyPosition.x += Me.speed*cos(Me.body_angle*PICKO/180);
		Me.MyPosition.y += Me.speed*sin(Me.body_angle*PICKO/180);
		Me.speed *= this->player_decay;
	}
}


CPlayer CEnvironment::stepPlayer(const CPlayer& HracOrig, int Step)
{
	CPlayer tmpHrac(HracOrig);
	
	//podla x a y, speed, body_angle, player_decay
	for (int i=1;i<=Step;i++) {
		tmpHrac.MyPosition.x += tmpHrac.speedX;
		tmpHrac.MyPosition.y += tmpHrac.speedY;
		tmpHrac.speedX *= this->player_decay;
		tmpHrac.speedY *= this->player_decay;
		//znizim urcitost pamate 
		tmpHrac.lowerProbability(PROBABILITY_STEP);	
	}

	return tmpHrac;
}


void CEnvironment::removePlayersInView()
{
	double minAngle, maxAngle;
	double dir;
	int i;

	switch (Me.vwidth) {
		case narrow: 
			minAngle = - 22.5; 
			maxAngle = + 22.5; 
			break;
		case normal: 
			minAngle = - 45; 
			maxAngle = + 45; 
			break;
		case wide: 
			minAngle = - 90; 
			maxAngle = + 90; 
			break;
	}
	//nasi 
	for (i=this->Nasi.GetUpperBound();i>=0;i--)
	{
		dir = (atan2((Nasi[i].MyPosition.y - Me.MyPosition.y), (Nasi[i].MyPosition.x - Me.MyPosition.x)))*180/PICKO - (Me.body_angle+Me.head_angle);
		if(int(dir) == 0) dir=0; //FIX
		while(dir<-180) dir+=360;
		while(dir>180) dir-=360;
		if ((dir>=minAngle)&&(dir<=maxAngle)) {
			Nasi.RemoveAt(i);
		}
	}
	//cudzi
	for (i=this->Cudzi.GetUpperBound();i>=0;i--)
	{
		dir = atan2((Cudzi[i].MyPosition.y - Me.MyPosition.y), (Cudzi[i].MyPosition.x - Me.MyPosition.x))*180/PICKO - (Me.body_angle+Me.head_angle);
		if(int(dir) == 0) dir=0; //FIX
		while(dir<-180) dir+=360;
		while(dir>180) dir-=360;
		if ((dir>=minAngle)&&(dir<=maxAngle)) {
			Cudzi.RemoveAt(i);		
		}
	}
	//lopta
	//ak je v zornom poli
	if (Lopta.probability) {
		dir = atan2((Lopta.MyPosition.y - Me.MyPosition.y), (Lopta.MyPosition.x - Me.MyPosition.x))*180/PICKO - (Me.body_angle+Me.head_angle);
		while(dir<-180) dir+=360;
		while(dir>180) dir-=360;
		if ((dir>=minAngle)&&(dir<=maxAngle)) Lopta.probability = 0;		
	}
	// alebo ak je blizsie ako 3 metre
	if (Lopta.probability) {
		if (sqrt((Lopta.MyPosition.x - Me.MyPosition.x)*(Lopta.MyPosition.x - Me.MyPosition.x) + (Lopta.MyPosition.y - Me.MyPosition.y)*(Lopta.MyPosition.y - Me.MyPosition.y) ) < 3) Lopta.probability = 0;		
	}
}

void CEnvironment::removeOlds()
{
	int i;

	//skontrolujeme nasich
	for (i=this->Nasi.GetUpperBound();i>=0;i--)
	{
		if (Nasi[i].probability == 0) {
			Nasi.RemoveAt(i);
		}
	}
	//skontrolujeme cudzich
	for (i=this->Cudzi.GetUpperBound();i>=0;i--)
	{
		if (Cudzi[i].probability == 0) {
			Cudzi.RemoveAt(i);
		}
	}
}

long CEnvironment::getNasHrac(CPlayer &Hrac)
{
	if (! (Hrac.Flag & P_NUMBER)) return -1;

	for (int i=0;i< Nasi.GetSize(); i++)
	{
		//dohladame podla dresu
		if ((Nasi[i].Flag & P_NUMBER) && (Nasi[i].UniformNumber == Hrac.UniformNumber))
				return i;
	}
	return -1;
}

long CEnvironment::getCudziHrac(CPlayer &Hrac)
{
	if (! (Hrac.Flag & P_NUMBER)) return -1;

	for (int i=0;i< Cudzi.GetSize(); i++)
	{
		//dohladame podla dresu
		if( (Cudzi[i].Flag & P_NUMBER) && (Cudzi[i].UniformNumber == Hrac.UniformNumber))
			return i;
	}
	return -1;
}

void CEnvironment::addNas(CPlayer &NovyHrac)
{
	long index;   //index hraca ak najde

	index = getNasHrac(NovyHrac);
	//vyhlada hraca (podla dresu a pribliznej polohy)
	if (index>=0) {
		//ak najde - nahradi ho
		Nasi[index] = NovyHrac;
	}
	else
	{
		//inak ho prida
		Nasi.Add(NovyHrac);
	}
}

void CEnvironment::addCudzi(CPlayer &NovyHrac)
{
	long index;   //index hraca ak najde

	index = getCudziHrac(NovyHrac);
	//vyhlada hraca (podla dresu a pribliznej polohy)
	if (index>=0) {
		//ak najde - nahradi ho
		Cudzi[index] = NovyHrac;
	}
	else
	{
		//inak ho prida
		Cudzi.Add(NovyHrac);
	}
}

