// Environment.h: interface for the CEnvironment class.
//
//////////////////////////////////////////////////////////////////////

#include "SharkTypes.h"
#include "ConfigFile.h"
#include "Player.h"
#include "RealPoint.h"

#if !defined(AFX_ENVIRONMENT_H__15D8E641_1538_11D5_A152_0020188DB7DA__INCLUDED_)
#define AFX_ENVIRONMENT_H__15D8E641_1538_11D5_A152_0020188DB7DA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


typedef struct _MyInfo {
	
	CRealPoint MyPosition;
	double stamina;
	double speed;
	double head_angle;				//relativny uhol voci telu
	double body_angle;				//abslutny uhol natocenia

	ViewWidth vwidth;

	int UniformNumber;
} MyInfo;

class CEnvironment: public CConfigFile  
{
public:
	BOOL	drawDRES;							//kreslit dres
	BOOL	drawVIEW;							//zobrazovat pohlad

	CEnvironment();
	virtual ~CEnvironment();

	// inicializacia sveta, bude sa volat z Handler_See
	// 1.oprava mojej pozicie (absolutna poloha)
	// 2.vyhodenie hracov v uhle pohladu z pamati
	// 3.naplnenie sveta podla VizInfo
	void updateWorld(VizInfo *Data);

	// nastavenie premennych tela volane z Handler_SenseBody
	// 1.nastavi hodnoty podla Info
	void updateMyBody(SenseBodyInfo *Info);

	// posunie svet o jeden krok na zaklade rychlosti, atd.
	// vyhodi starych
	void stepWorld(int Step=1);

	//vykreslenie pamati 
	void drawMemory(CDC &dc, CRect Rect);

protected: 
	CArray<CPlayer,CPlayer> Nasi;				//svet nasich hracov
	CArray<CPlayer,CPlayer> Cudzi;
	CPlayer Lopta;									// lopta
	MyInfo Me;

	//posun lopty o n krokov
	CPlayer stepBall(const CPlayer& LoptaOrig, int Step);
	//posun jedneho hraca o n krokov
	CPlayer stepPlayer(const CPlayer& HracOrig, int Step);

private:
	float	ZOOM;							//zvacsenie ihriska
	int		PLAYER_WIDTH;					//velkost hraca
	int		BALL_WIDTH;						//velkost lopty

	//posun mna o n krokov
	void stepMe(int Step);

	//vyhodi z databazy prilis stare (neurcite) objekty
	void removeOlds(void);
	
	//vyhodi tych hracov, ktori su v pamati v tej casti, ktoru vidim
	//do tejto casti sa potom doplnia ti, ktorych realne vidim
	void removePlayersInView();

	//pozicie znaciek
	void GetLandmarkPos(DWORD prop1,DWORD prop2,DWORD prop3,double* X,double* Y);

	//vypocita pozicia pozorovatela
	BOOL CalcAbsPos(VizInfo* vinfo,double* X,double* Y,double* viewdir);

	//prida hraca (ak uz je znamy tak ho opravi)
	void addNas(CPlayer &NovyHrac);
	//najde zadaneho hraca a vrati jeho index v Nasi
	//ak nenajde, vrati -1
	long getNasHrac(CPlayer &Hrac);
	long getCudziHrac(CPlayer &Hrac);

	//prida hraca (ak uz je znamy tak ho opravi)
	void addCudzi(CPlayer &NovyHrac);

	//vykresli mna
	void drawMe(CDC &dc, float x0, float y0);
	//vykresli loptu
	void drawBall(CDC &dc, float x0, float y0);
	//vykresli spoluhraca
	void drawFriend(CDC &dc, CPlayer &Hrac, float x0, float y0);
	//vykresli protihraca
	void drawEnemy(CDC &dc, CPlayer &Hrac, float x0, float y0);
	//vykresli ihrisko
	void drawPlayground(CDC &dc, CRect Rect, float x0, float y0);


/*	- pridaj objekt
    - zrus objekt
    - uprav objekt (uprav urcitost objektu)

   (vyhladavanie hracov podla cisla, dresu, pozicie,
    ak neviem ani cislo ani dres len poziciu, tak mozem 
    vediet, ci sa neposunul niekto o kom viem, ze bol 
    v tej pozicii - potom by som vedel cislo aj o tom hracovi,
    u ktoreho to nevidim) */

};

#endif // !defined(AFX_ENVIRONMENT_H__15D8E641_1538_11D5_A152_0020188DB7DA__INCLUDED_)
