// HighAgent.cpp: implementation of the CHighAgent class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "sharks.h"
#include "HighAgent.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CHighAgent::CHighAgent()
{
	Spravanie=None;
	mode=PM_None;

	//pozicie
	Pozicie[0]=CRealPoint(-50,0);
	Pozicie[1]=CRealPoint(-10,0);
	Pozicie[2]=CRealPoint(-13,0);
	Pozicie[3]=CRealPoint(-5,-15);
	Pozicie[4]=CRealPoint(-5,15);
	Pozicie[5]=CRealPoint(-PWIDTH,-PHEIGHT);
	Pozicie[6]=CRealPoint(-PWIDTH,PHEIGHT);
	Pozicie[7]=CRealPoint(-25,-10);
	Pozicie[8]=CRealPoint(-25,10);
	Pozicie[9]=CRealPoint(-20,-20);
	Pozicie[10]=CRealPoint(-20,20);
	Pozicie[11]=CRealPoint(-30,0);

}

CHighAgent::~CHighAgent()
{

}

void CHighAgent::Handler_NewCycle()
{
	Kresli();

	switch(Spravanie)
	{
	case None:
		//nerobim nic
		break;
	case Tutmak:
		Player_Tutmak();
		break;
	case GoalPerson:
		Player_GoalPerson();
		break;
	case Attacker:
		Player_Attacker();
		break;

	}
}

void CHighAgent::Handler_Login(int Cislo,BOOL lava_strana)
{
	CLowAgent::Handler_Login(Cislo,lava_strana);
	ourLeftSide=lava_strana;
	Me.UniformNumber=Cislo;

	if(m_GoalPerson)
	{
		JumpToHomePos();
		Spravanie=GoalPerson;
	}
	else
	{
		JumpToHomePos();
		Spravanie=Tutmak;
	}

	Change_View(wide);
}

void CHighAgent::Handler_ChangeMode(PlayMode mod,int cas)
{
	mode=mod;
	CLowAgent::Handler_ChangeMode(mod,cas);
}
void CHighAgent::Player_Tutmak()
{
	switch(mode)
	{
	case PM_before_kick_off:
	case PM_GOAL_L:
	case PM_GOAL_R:
		{
			double tx=(ourLeftSide ? Pozicie[Me.UniformNumber].x : -Pozicie[Me.UniformNumber].x);
			double dx=tx-Me.MyPosition.x;
			double dy=Pozicie[Me.UniformNumber].y-Me.MyPosition.y;

			if(sqrt(dx*dx+dy*dy)>3)
			{
				JumpToHomePos();
			}
			else
			{
				if(Lopta.probability>0)
				{
					LookAtBall();
				}
				else
				{
					SateliteScan();
				}
			}
		}
		break;
	default:
		if(Lopta.probability>0) //viem o lopte
		{
			if(IsBallKickAble())
			{
				int who=FindPassAblePlayer();
				if(who==-1)
				{
					KickToGoal();
				}
				else
				{
					PassBallTo(Nasi[who]);
				}
			}
			else
			{
				if(Responsibility4Ball())
				{
					RunToBall();
				}
				else
				{
					CRealPoint pos=defaultPlayerPos(Me.UniformNumber,ourLeftSide,FALSE);
					double dx=pos.x-Me.MyPosition.x;
					double dy=pos.y-Me.MyPosition.y;
					double dist=sqrt(dx*dx+dy*dy);

					if(dist<10)
					{
						LookAtBall();
					}
					else
					{
						RunTo(pos.x,pos.y);
					}
				}
			}
		}
		else //netusim kde je lopta
		{
			SateliteScan();
		}
	}
}

void CHighAgent::Player_GoalPerson()
{
	if(Lopta.probability>0) //vidim
	{
		if(IsBallCatchAble() && mode==PM_play_on)
		{
			DoCatchBall();
		}
		else if(IsBallKickAble())
		{
			KickToGoal();
		}
		else
		{
			if(IsBallNearGoal(ourLeftSide))
			{
				RunToBall();
			}
			else
			{
				if(!RunTo((ourLeftSide) ? -50 : 50,0))
					LookAtBall();
			}
		}
	}
	else //nevidim
	{
		SateliteScan();
	}
}

void CHighAgent::JumpToHomePos()
{
	if(mode!=PM_before_kick_off && mode!=PM_GOAL_L && mode!=PM_GOAL_R) return;
	CRealPoint p;
	int x,y;

	if(m_GoalPerson)
	{
		p=Pozicie[0];
	}
	else
	{
		p=Pozicie[Me.UniformNumber];
	}

	x=int(p.x);
	y=int(p.y);
	if(!ourLeftSide) y*=-1;

	Move(x,y);
	cPrint(CString("Teleporting...\n"),14);

}

BOOL CHighAgent::ExistsNearestPlayerToBall()
{
	double dist;
	double mydist;
	int count = 0;			//pocet blizsich ako ja

	mydist = sqrt((Me.MyPosition.x - Lopta.MyPosition.x)*(Me.MyPosition.x - Lopta.MyPosition.x) + (Me.MyPosition.y - Lopta.MyPosition.y)*(Me.MyPosition.y - Lopta.MyPosition.y));

	for (int i=0; i < Nasi.GetSize(); i++) {
		dist = sqrt((Nasi[i].MyPosition.x - Lopta.MyPosition.x)*(Nasi[i].MyPosition.x - Lopta.MyPosition.x) + (Nasi[i].MyPosition.y - Lopta.MyPosition.y)*(Nasi[i].MyPosition.y - Lopta.MyPosition.y));
		if (dist < mydist) {
			count++;
		}
	}

	if (count >= 1 ) return TRUE;
	return FALSE;
}

void CHighAgent::RunToGoal()
{
	double targetx, targety;

	if(ourLeftSide)
	{
		targetx=FWIDTH - 10;
	}
	else
	{
		targetx=-FWIDTH + 10;
	}
	targety = 0;

	CPlayer tmpBall;

	tmpBall = stepBall(Lopta,20);

	RunTo(tmpBall.MyPosition.x ,tmpBall.MyPosition.y);
}

void CHighAgent::Player_Attacker()
{
	if(Lopta.probability>0) //vidim
	{
		if(IsBallKickAble())
		{
			KickToGoal();
		}
		else
		{ 
			if (ExistsNearestPlayerToBall()) 
			{
				RunToGoal();
			}
			else
			{
				RunToBall();
			}
		}
	}
	else //nevidim
	{
		SateliteScan();
	}
}

