// LogFile.cpp: implementation of the CLogFile class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "sharks.h"
#include "LogFile.h"
#include <fstream.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLogFile::CLogFile()
{

}

CLogFile::~CLogFile()
{

}

void CLogFile::addEvent(DWORD t, CString msg)
{
	LogDB.Add(CLogEvent(t,msg));
}

void CLogFile::clearLog()
{
	LogDB.RemoveAll();
}


BOOL CLogFile::saveLog(const char *fname)
{
	fstream fs;
	unsigned len;     //pocet udalosti
	unsigned msglen;  //dlzka spravy
	DWORD t;		  //pocet tikov
	CString s;		  //sprava

	fs.open(fname, ios::binary | ios::out);
    if (fs.good()){
		
		//meno timu
		len = team_name.GetLength();
		if (len==0) {
			fs.close();
			return false;
		}
	    fs.write((unsigned char *) &len, sizeof(unsigned) / sizeof(unsigned char));
		fs.write((unsigned char *) (LPCTSTR) team_name, len);
		//pocet udalosti
		len = LogDB.GetSize();
	    fs.write((unsigned char *) &len, sizeof(unsigned) / sizeof(unsigned char));
		for (unsigned i=0;i < len; i++)
		{
			t = LogDB.GetAt(i).ticks;
		    fs.write((unsigned char *) &t, sizeof(unsigned) / sizeof(unsigned char));
			s = LogDB.GetAt(i).message;
			msglen = s.GetLength();
		    fs.write((unsigned char *) &msglen, sizeof(unsigned) / sizeof(unsigned char));
			fs.write((unsigned char *) (LPCTSTR) s, msglen);
		}

		fs.close();
		return TRUE;
	} else 
		return FALSE;
}

BOOL CLogFile::loadLog(const char *fname)
{
	fstream fs;
	unsigned len;     //pocet udalosti
	unsigned msglen;  //dlzka spravy
	DWORD t;		  //pocet tikov
	CString s;		  //sprava
	char znak;		  //jeden zacitany znak


	LogDB.RemoveAll();
	fs.open(fname, ios::binary | ios::in);
    if (fs.good()){
		
		//dlzku nazvu
	    fs.read((unsigned char *) &len, sizeof(unsigned) / sizeof(unsigned char));
		team_name.Empty();
		for (unsigned int j=0; j<len; j++) {
			fs.read((unsigned char *) &znak, 1);
			team_name += znak;
		}
		
		//pocet udalosti
	    fs.read((unsigned char *) &len, sizeof(unsigned) / sizeof(unsigned char));
		for (unsigned i=0;i < len; i++)
		{
		    fs.read((unsigned char *) &t, sizeof(unsigned) / sizeof(unsigned char));
		    fs.read((unsigned char *) &msglen, sizeof(unsigned) / sizeof(unsigned char));
			s.Empty();
			for (unsigned int j=0; j<msglen; j++) {
				fs.read((unsigned char *) &znak, 1);
				s += znak;
			}
			addEvent(t,s);
		}

		fs.close();
		return TRUE;
	} else 
		return FALSE;
}
