// LowAgent.h: interface for the CLowAgent class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LOWAGENT_H__6E995B70_0F42_11D5_9F49_444553540001__INCLUDED_)
#define AFX_LOWAGENT_H__6E995B70_0F42_11D5_9F49_444553540001__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Agentsock.h"
#include "LogFile.h"

class CLowAgent : private CAgentSocket  
{
public:
	int m_DebugLogIndex;
	void ReceiveLogEvent();
	CLogFile m_DebugLog;
	BOOL m_DebugRecord;
	DWORD m_DebugTicks;
	BOOL m_DebugMode;
	DWORD GetTicks();
	void Turn_Neck(int angle);
	void Turn(int moment);
	void Move(int x,int y);
	void Kick(int power,int direction);
	void Dash(int power);
	void Change_View(ViewWidth vwidth);
	void Catch(int direction);
	void SenseBody();
	CString m_NazovTimu;
	void Say(CString& pokec);
	//ci je napojeny na server
	BOOL m_TryingToConnect;
	//ci sa prave pripaja na server
	BOOL m_IsConnected;
//	BOOL ConnectAgent();
	BOOL ConnectAgentEx(CString	TeamName, CString SocServer, UINT	SocPort, BOOL	GoalPerson);
	CLowAgent();
	virtual ~CLowAgent();

protected:
	BOOL m_GoalPerson;
	virtual void Handler_Dash(int power);
	virtual void Handler_TurnNeck(int angle);
	virtual void Handler_Turn(int moment);
	virtual void Handler_SenseBody(SenseBodyInfo* sinf,int cas);
	virtual void Handler_See(VizInfo* vinfo,int cas);
	virtual void Handler_Hear(int direction,CString& sprava,int cas);
	virtual void Handler_Login(int Cislo,BOOL lava_strana);
	virtual void Handler_ChangeMode(PlayMode mod,int cas);
	void SendMsg(CString& msg);

private:
	void ParseReceive(LPCSTR buf);
	void ParseReconnect(LPCSTR message);
	void ParseInit(LPCSTR message);
	void ParseSense_Body(LPCSTR message);
	void ParseSee(LPCSTR message);
	void ParseHear(LPCSTR message);
	void OsetriSokError(int e);

	virtual void OnReceive(int nErrorCode);

	DWORD FlagParams(CString& str);
};

#endif // !defined(AFX_LOWAGENT_H__6E995B70_0F42_11D5_9F49_444553540001__INCLUDED_)
