// MedAgent.h: interface for the CMedAgent class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MEDAGENT_H__52381DE3_1D56_11D5_9F49_444553540001__INCLUDED_)
#define AFX_MEDAGENT_H__52381DE3_1D56_11D5_9F49_444553540001__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Environment.h"
#include "LowAgent.h"
#include "Player.h"	// Added by ClassView

class CMedAgent : 
	public CLowAgent, 
	public CEnvironment  
{
public:
	BOOL ConnectAgent();
	BOOL INIConnectAgent(CWnd *wnd);
	int GetSimTime() const;
	CWnd* m_output;
	void LookAtBall();
	void SateliteScan();
	void RunToBall();
	BOOL OnExternTimer();
	void CreateTimer(CWnd* okno);
	UINT sync_TimerNumber;
	void SayMyPos();
	BOOL RunTo(double X,double Y);
	void KickToGoal();
	CMedAgent();
	virtual ~CMedAgent();

protected:
	void PassBallTo2(const CPlayer &spoluHrac);
	void DoCatchBall();
	BOOL IsFree(int spoluhrac);
	int FindPassAblePlayer();
	BOOL Responsibility4Ball();
	int CloserEnemy2Ball(double* dist);
	int CloserFriend2Ball(double* dist);
	void PassBallTo(const CPlayer& spoluHrac);
	int sync_SimTime;
	void Kresli();
	BOOL IsBallCatchAble();
	BOOL IsBallNearGoal(BOOL side);
	BOOL ourLeftSide;
	virtual void Handler_Turn(int moment);
	BOOL IsBallKickAble();
	virtual void Handler_NewCycle();
	virtual void Handler_See(VizInfo* vinfo,int cas);
	virtual void Handler_SenseBody(SenseBodyInfo* sinf,int cas);
	virtual void Handler_Hear(int direction,CString& sprava,int cas);
	virtual void Handler_Dash(int power);
	virtual void Handler_TurnNeck(int angle);

private:
	int LastPassBallCycle;
	int PredictSteps(double dist,double aktSpeed);
	int Calc_Moment(int angle);
	int Last_catchCycle;
	BOOL WillWaitForVI;
	BOOL IsWaitingForVI;
	void ApplyLastCommands();
	int last_angle;
	int last_power;
	int last_moment;
	int sync_LastVI_SimTime;
	DWORD sync_LastComm_TickCount;
	void Calc_DirDist(double dX,double dY,double sDir,int* dir,double* dist);

};

#endif // !defined(AFX_MEDAGENT_H__52381DE3_1D56_11D5_9F49_444553540001__INCLUDED_)
