// Player.cpp: implementation of the CPlayer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Sharks.h"
#include "Player.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPlayer::CPlayer()
{
	Flag=0;
	UniformNumber=0;
	speedX = 0;
	speedY = 0;
}

CPlayer::CPlayer(const CPlayer& other)
{
	Flag = other.Flag;
	MyPosition = other.MyPosition;
	probability = other.probability;
	speedX = other.speedX;
	speedY = other.speedY;
	UniformNumber = other.UniformNumber;
}

CPlayer& CPlayer::operator=(const CPlayer& other)
{
	if(&other == this) return *this;

	Flag = other.Flag;
	MyPosition = other.MyPosition;
	probability = other.probability;
	speedX = other.speedX;
	speedY = other.speedY;
	UniformNumber = other.UniformNumber;

	return *this;
}

CPlayer::~CPlayer()
{

}

void CPlayer::lowerProbability(int delta)
{
	if (probability) {
		probability -= delta;
		if (probability<0) { probability = 0; }
	}

}

void CPlayer::resetProbability()
{
	probability = PROBABILITY_MAX;
}

//nastavenie smeru a rychlosti
/*
        Zistenie relativnej rychlosti
        (Rx,Ry) - relativna vzdialenost od pozorovatela
        obj		- objekt, ktoreho relativnu rychlost zistujem
        (Wx,Wy) - relativna rychlost
*/
void CPlayer::setProps(double refX, double refY, double refSpeedX, double refSpeedY, double DirChng, double DistChng)
{
	double vx, vy;

	double R=sqrt((this->MyPosition.x - refX)*(this->MyPosition.x - refX) + (this->MyPosition.y - refY)*(this->MyPosition.y - refY));
	double Ex=(this->MyPosition.x - refX)/R;
	double Ey=(this->MyPosition.y - refY)/R;
	double Dirch=DirChng * PICKO/180;

	vx=DistChng*Ex - Dirch * (this->MyPosition.y - refY);
	vy=DistChng*Ey + Dirch * (this->MyPosition.x - refX);
	
	speedX = 0.25* speedX + 0.75* (vx + refSpeedX);
	speedY = 0.25* speedY + 0.75* (vy + refSpeedY);
	//strana main.pdf (52, 26)
}

