/*
Nejake struktury a definicie
*/
#ifndef __SHARKTYPES__
#define __SHARKTYPES__

#define NO_OF_PLAYMODES 18
#define PLAYMODE_STRINGS {"",\
                        "before_kick_off",\
                        "kick_off_l",\
                        "kick_off_r",\
                        "kick_in_l",\
                        "kick_in_r",\
                        "corner_kick_l",\
                        "corner_kick_r",\
                        "goal_kick_l",\
                        "goal_kick_r",\
                        "free_kick_l",\
                        "free_kick_r",\
                        "offside_l",\
                        "offside_r",\
                        "play_on",\
                        "half_time",\
                        "time_up",\
                        "extend",\
						"goal_l",\
						"goal_r",\
						}
enum PlayMode
{
	PM_None,
	PM_before_kick_off,
	PM_kick_off_l,
	PM_kick_off_r,
	PM_kick_in_l,
	PM_kick_in_r,
	PM_corner_kick_l,
	PM_corner_kick_r,
	PM_goal_kick_l,
	PM_goal_kick_r,
	PM_free_kick_l,
	PM_free_kick_r,
	PM_offside_l,
	PM_offside_r,
	PM_play_on,
	PM_half_time,
	PM_time_up,
	PM_extend,
	//dalsie (inak sa rozoznavaju)
	PM_GOAL_L,
	PM_GOAL_R

};

#define MsgB(sprava) MessageBox(NULL,sprava,"Pomocny vypis",MB_OK)

#define MAX_CIARA 4
typedef struct _Ciara
{
	DWORD properties;
	double distance;
	double direction;
}Ciara;

#define L_EMPTY 0
#define L_LEFT	0x1
#define L_RIGHT	0x2
#define L_TOP	0x8
#define L_BOTTON	0x10

#define MAX_FLAG 53
typedef struct _Flag
{
	DWORD prop1;
	DWORD prop2;
	DWORD prop3;
	double distance;
	double direction;
}Flag;

#define F_EMPTY 0

#define F_LEFT	0x1
#define F_RIGHT	0x2
#define F_CENTER	0x4
#define F_TOP	0x8
#define F_BOTTON	0x10

#define F_GOAL	0x20
#define F_PENALTY	0x40

#define F_0		0x80
#define F_10	0x100
#define F_20	0x200
#define F_30	0x400
#define F_40	0x800
#define F_50	0x1000

#define F_GOALFLAG	0x2000

//polovica sirky ihriska
#define FWIDTH	52.5
//polovica vysky ihriska
#define FHEIGHT	34
//x pokutoveho
#define PWIDTH	36
//y pokutoveho
#define PHEIGHT	20.16

typedef struct _Player
{
	DWORD properties;
	double distance;
	double direction;
	double distchng;
	double dirchng;
	double faceDir;
	double bodyDir;

	int UniformNumber;
}Player;

#define P_EMPTY	0

#define P_DISTANCE	0x1
#define P_DIRECTION	0x2
#define P_DISTCHNG	0x4
#define P_DIRCHNG	0x8

#define P_FACEDIR	0x10
#define P_BODYDIR	0x20
#define P_NUMBER	0x40

typedef struct _VizInfo
{
	unsigned nCiary;
	Ciara* Ciary;
	unsigned nFlagy;
	Flag* Flagy;
	unsigned nNasi;
	Player* Nasi;
	unsigned nCudzi;
	Player* Cudzi;
	unsigned nNeutralny;
	Player* Neutralny;

	Player* lpLopta;
}VizInfo;

enum ViewQuality
{
	low,
	high
};

enum ViewWidth
{
	narrow,
	normal,
	wide
};

typedef struct _SenseBodyInfo
{
	ViewQuality vquality;
	ViewWidth vwidth;
	double stamina;
	double Effort;
	double speed;
	double head_angle;
	int kick_count;
	int dash_count;
	int turn_count;
	int say_count;
	int turnneck_count;
}SenseBodyInfo;

#define PICKO	3.1415926535897932384626433832795

//typy spravania
enum Behaviour
{
	None,
	Tutmak,
	GoalPerson,
	Attacker
};

#endif